#include<bits/stdc++.h>
using namespace std;

const int64_t INF = 1e17;
const int N = 5e4+1;


vector<pair<int,int>> tarikland[N];
vector<pair<int,int>> melihland[N];
vector<int64_t> valT(N, INF), valM(N, INF);

int main(){
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	
	int n, A, B;
	cin >> n >> A >> B;

	for(int i = 0, x, y, z; i < A; i++){
		cin >> x >> y >> z;
		tarikland[x].push_back({y, z});
		tarikland[y].push_back({x, z});
	}
	for(int i = 0, x, y, z; i < B; i++){
		cin >> x >> y >> z;
		melihland[x].push_back({y, z});
		melihland[y].push_back({x, z});
	}

	priority_queue<pair<int64_t,int>,vector<pair<int64_t,int>>,greater<pair<int64_t,int>>> Q;
	vector<bool> visited(N, false);
	valT[1] = 0;
	Q.push({0, 1});
	
	while(!Q.empty()){
		int x = Q.top().second;
		Q.pop();
		if(visited[x]) continue;
		visited[x] = true;
		for(auto e : tarikland[x]){
			int y = e.first, z = e.second;
			if(valT[y] > valT[x] + z){
				valT[y] = valT[x] + z;
				Q.push({valT[y], y});
			}
		}
	}
	
	visited = vector<bool> (N, false);
	valM[n] = 0;
	Q.push({0, n});
	
	while(!Q.empty()){
		int x = Q.top().second;
		Q.pop();
		if(visited[x]) continue;
		visited[x] = true;
		for(auto e : melihland[x]){
			int y = e.first, z = e.second;
			if(valM[y] > valM[x] + z){
				valM[y] = valM[x] + z;
				Q.push({valM[y], y});
			}
		}
	}
	
	int64_t maxpath = 0, ans = 0;
	for(int i = 1; i <= n; i++) maxpath = max(maxpath, valT[i] + valM[i]);
	for(int i = 1; i <= n; i++) ans += maxpath - (valT[i] + valM[i]);

	cout << ans;
	
}