/*
	Author: 				Hamza
	Description: 			O(N) solution by storing the locations of each
							color on separate vectors and calculating the contribution
							of each color to the total answer.
*/

#include<bits/stdc++.h>
#define ll long long
#define N 200005
using namespace std;

int n;
int b[2][N];
vector<int> v[N];

ll contrib(int c) {

	ll result = 0;
	for(int i = 0; i < v[c].size(); i++) {
		int h = i;
		while(i + 1 < v[c].size() and v[c][i + 1] == v[c][i] + 1)
			i++;
		int cnt = i - h + 1;
		result += (ll) cnt * (cnt + 1) / 2;
	}
	return result;

}

int main() {

	ios_base :: sync_with_stdio(0);
	cin.tie(0);cout.tie(0);

	cin >> n;
	for(int w = 0; w < 2; w++) 
		for(int i = 0; i < n; i++) 
			cin >> b[w][i];	

	for(int i = 0; i < n; i++) {
		v[b[0][i]].push_back(i);
		if(b[0][i] != b[1][i])
			v[b[1][i]].push_back(i);	
	}
	ll total = 0;
	for(int c = 1; c <= n; c++)
		total += contrib(c);
	cout << total;

}